; 
    include \masm32\include\masm32rt.inc
    include \masm32\include\wininet.inc
    includelib \masm32\lib\wininet.lib
; 

ADDS MACRO psz

   invoke SendMessage, hwndStatus, LB_ADDSTRING, 0, psz

   ;----------------------------------------------------------
   ; Select the string and scroll it into view, if necessary.
   ;----------------------------------------------------------

   invoke SendMessage, hwndStatus, LB_SETCURSEL, eax, 0

ENDM

; 

IDC_EDIT_SERVER   equ 100
IDC_EDIT_FILENAME equ 101
IDC_LIST_STATUS   equ 102
IDC_BUTTON        equ 103

; 
    .data
      hInstance   dd 0
      hwndStatus  dd 0
      context     dd 0
      counter     dd 0
      buff        db 256 dup(0)
    .code
; 

InternetStatusCallback proc hInternet:DWORD,
                            dwContext:DWORD,
                            dwInternetStatus:DWORD,
                            lpvStatusInformation:DWORD,
                            dwStatusInformationLength:DWORD

    ;----------------------------------------------
    ; The INTERNET_STATUS constants are limited to
    ; those defined in windows.inc.
    ;----------------------------------------------

    SWITCH dwInternetStatus
        CASE INTERNET_STATUS_RESOLVING_NAME
            ADDS chr$("INTERNET_STATUS_RESOLVING_NAME")
        CASE INTERNET_STATUS_NAME_RESOLVED
            ADDS chr$("INTERNET_STATUS_NAME_RESOLVED")
        CASE INTERNET_STATUS_CONNECTING_TO_SERVER
            ADDS chr$("INTERNET_STATUS_CONNECTING_TO_SERVER")
        CASE INTERNET_STATUS_CONNECTED_TO_SERVER
            ADDS chr$("INTERNET_STATUS_CONNECTED_TO_SERVER")
        CASE INTERNET_STATUS_SENDING_REQUEST
            ADDS chr$("INTERNET_STATUS_SENDING_REQUEST")
        CASE INTERNET_STATUS_REQUEST_SENT
            ADDS chr$("INTERNET_STATUS_REQUEST_SENT")
        CASE INTERNET_STATUS_RECEIVING_RESPONSE
            ADDS chr$("INTERNET_STATUS_RECEIVING_RESPONSE")
        CASE INTERNET_STATUS_RESPONSE_RECEIVED
            ADDS chr$("INTERNET_STATUS_RESPONSE_RECEIVED")
        CASE INTERNET_STATUS_CTL_RESPONSE_RECEIVED
            ADDS chr$("INTERNET_STATUS_CTL_RESPONSE_RECEIVED")
        CASE INTERNET_STATUS_PREFETCH
            ADDS chr$("INTERNET_STATUS_PREFETCH")
        CASE INTERNET_STATUS_CLOSING_CONNECTION
            ADDS chr$("INTERNET_STATUS_CLOSING_CONNECTION")
        CASE INTERNET_STATUS_CONNECTION_CLOSED
            ADDS chr$("INTERNET_STATUS_CONNECTION_CLOSED")
        CASE INTERNET_STATUS_HANDLE_CREATED
            ADDS chr$("INTERNET_STATUS_HANDLE_CREATED")
        CASE INTERNET_STATUS_HANDLE_CLOSING
            ADDS chr$("INTERNET_STATUS_HANDLE_CLOSING")
        CASE INTERNET_STATUS_REQUEST_COMPLETE
            ADDS chr$("INTERNET_STATUS_REQUEST_COMPLETE")
        CASE INTERNET_STATUS_REDIRECT
            ADDS chr$("INTERNET_STATUS_REDIRECT")
        CASE INTERNET_STATUS_INTERMEDIATE_RESPONSE
            ADDS chr$("INTERNET_STATUS_INTERMEDIATE_RESPONSE")
        CASE INTERNET_STATUS_STATE_CHANGE
            ADDS chr$("INTERNET_STATUS_STATE_CHANGE")
    ENDSW

    ret

InternetStatusCallback endp

; 


ThreadProc proc uses ebx lpParameter:DWORD

    LOCAL hSession:DWORD, hConnect:DWORD

    mov ebx, lpParameter
    mov ebx, [ebx]

    invoke InternetOpen, chr$("Test"),
                         INTERNET_OPEN_TYPE_PRECONFIG,
                         NULL,
                         NULL,
                         0
    mov hSession, eax
    .IF eax == 0
        ADDS chr$("InternetOpen FAILED")
        jmp @F
    .ELSE
        ADDS chr$("InternetOpen OK")
    .ENDIF

    invoke GetDlgItemText, ebx, IDC_EDIT_SERVER, ADDR buff, SIZEOF buff

    invoke InternetConnect, hSession,
                            ADDR buff,
                            INTERNET_INVALID_PORT_NUMBER,
                            NULL,
                            NULL,
                            INTERNET_SERVICE_FTP,
                            0,
                            ADDR context
    mov hConnect, eax
    .IF eax == 0
        ADDS chr$("InternetConnect FAILED")
        jmp @F
    .ELSE
        ADDS chr$("InternetConnect OK")
    .ENDIF

    invoke InternetSetStatusCallback, hConnect, InternetStatusCallback

    invoke GetDlgItemText, ebx, IDC_EDIT_FILENAME, ADDR buff, SIZEOF buff

    invoke FtpGetFile, hConnect,
                       ADDR buff,
                       chr$("junk.txt"),
                       0,
                       0,
                       0,
                       0
    .IF eax == 0
        ADDS chr$("FtpGetFile FAILED")
        jmp @F
    .ELSE
        ADDS chr$("FtpGetFile OK")
    .ENDIF

  @@:

    invoke InternetCloseHandle, hConnect
    invoke InternetCloseHandle, hSession

    invoke InternetSetStatusCallback, hConnect, NULL

    ret

ThreadProc endp

; 

DlgProc proc hwndDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    SWITCH uMsg

      CASE WM_INITDIALOG

          invoke GetDlgItem, hwndDlg, IDC_LIST_STATUS
          mov hwndStatus, eax

          invoke SetTimer, hwndDlg, 1, 10, NULL

          ;--------------------
          ; Load the defaults.
          ;--------------------

          invoke SetDlgItemText, hwndDlg, IDC_EDIT_SERVER,
                                 chr$("ftp.microsoft.com")
          invoke SetDlgItemText, hwndDlg, IDC_EDIT_FILENAME,
                                 chr$("/MISC/STORE1/WEEKLY.002")

      CASE WM_TIMER

          ;---------------------------------------------------------
          ; Provide an indication that the message loop is running.
          ;---------------------------------------------------------

          inc counter
          invoke SetWindowText, hwndDlg, ustr$(counter)

      CASE WM_COMMAND

        SWITCH wParam

          CASE IDC_BUTTON

              ;---------------------------
              ; Launch the worker thread.
              ;---------------------------

              invoke CreateThread, 0, 0, ThreadProc, ADDR hwndDlg, 0, 0

          CASE IDCANCEL

              invoke EndDialog, hwndDlg, 0

        ENDSW

      CASE WM_CLOSE

          invoke EndDialog, hwndDlg, 0

    ENDSW

    return 0

DlgProc endp

; 
start:
; 

    invoke GetModuleHandle, NULL
    mov hInstance, eax

    Dialog "Test","MS Sans Serif",10, \
            WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
            4,0,0,203,150,1024

    DlgEdit WS_BORDER or WS_TABSTOP or ES_AUTOHSCROLL, \
            10,10,120,10,IDC_EDIT_SERVER

    DlgEdit WS_BORDER or WS_TABSTOP or ES_AUTOHSCROLL, \
            10,30,180,10,IDC_EDIT_FILENAME

    DlgList WS_BORDER or WS_VSCROLL or LBS_NOINTEGRALHEIGHT, \
            10,50,180,80,IDC_LIST_STATUS

    DlgButton "Get File",0,140,10,50,10,IDC_BUTTON

    CallModalDialog hInstance,0,DlgProc,NULL

    exit

; 
end start